Loading...
Searching...
No Matches
Sip_unknown

## Macros

#define | sip_unknown(sip)
| Access a SIP unknown headers structure sip_unknown_t from sip_t.
#define | SIP_UNKNOWN_INIT()
| Initializer for structure sip_unknown_t.
#define | SIPTAG_UNKNOWN(x)
| Tag list item for pointer to a unknown headers structure sip_unknown_t.
#define | SIPTAG_UNKNOWN_REF(x)
| Tag list item for reference to a unknown headers pointer.
#define | SIPTAG_UNKNOWN_STR(s)
| Tag list item for string with unknown headers value.
#define | SIPTAG_UNKNOWN_STR_REF(x)
| Tag list item for reference to a unknown headers string.

## Typedefs

typedef msg_unknown_t | sip_unknown_t
| @

## Functions

issize_t | sip_unknown_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP unknown headers.
issize_t | sip_unknown_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP unknown headers.
sip_unknown_t * | sip_unknown_init (sip_unknown_t x[1])
| Initialize a structure sip_unknown_t.
int | sip_is_unknown (sip_header_t const *header)
| Test if header object is instance of sip_unknown_t.
sip_unknown_t * | sip_unknown_dup (su_home_t *home, sip_unknown_t const *hdr))
| Duplicate a list of unknown headers header structures sip_unknown_t.
sip_unknown_t * | sip_unknown_copy (su_home_t *home, sip_unknown_t const *hdr))
| Copy a list of unknown headers header structures sip_unknown_t.
sip_unknown_t * | sip_unknown_make (su_home_t *home, char const *s))
| Make a unknown headers structure sip_unknown_t.
sip_unknown_t * | sip_unknown_format (su_home_t *home, char const *fmt,...)))
| Make a unknown headers from formatting result.

## Variables

msg_hclass_t | sip_unknown_class []
| Header class for unknown headers.
tag_typedef_t | siptag_unknown
| Tag for unknown headers object.
tag_typedef_t | siptag_unknown_str
| Tag for string with unknown headers value.

## Detailed Description

## Macro Definition Documentation

## SIP_UNKNOWN_INIT

#define SIP_UNKNOWN_INIT | ( |  | ) |

Initializer for structure sip_unknown_t.

A static sip_unknown_t structure for unknown headers must be initialized with the SIP_UNKNOWN_INIT() macro. For instance,

sip_unknown_t sip_unknown = SIP_UNKNOWN_INIT;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_unknown
#define sip_unknown(sip)
Access a SIP unknown headers structure sip_unknown_t from sip_t.
Definition sip_protos.h:16077
SIP_UNKNOWN_INIT
#define SIP_UNKNOWN_INIT()
Initializer for structure sip_unknown_t.
Definition sip_protos.h:16094

## SIPTAG_UNKNOWN

#define SIPTAG_UNKNOWN | ( |  | x | ) |

Tag list item for pointer to a unknown headers structure sip_unknown_t.

The SIPTAG_UNKNOWN() macro is used to include a tag item with a pointer to a sip_unknown_t structure in a tag list.

Parameters

  x | pointer to a sip_unknown_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_UNKNOWN_REF().

## SIPTAG_UNKNOWN_STR

#define SIPTAG_UNKNOWN_STR | ( |  | s | ) |

Tag list item for string with unknown headers value.

The SIPTAG_UNKNOWN_STR() macro is used to include a tag item with a string containing value of a sip_unknown_t header in a tag list.

Parameters

  s | pointer to a string containing unknown headers value, or NULL.

The string in SIPTAG_UNKNOWN_STR() can be converted to a sip_unknown_t header structure by giving the string s has second argument to function sip_unknown_make().

The corresponding tag taking reference parameter is SIPTAG_UNKNOWN_STR_REF().

## Typedef Documentation

## sip_unknown_t

typedef msg_unknown_t sip_unknown_t

@

The unknown headers are handled with sip_unknown_t structure. The unknown header name is stored in un_name field and the header field following the colon is stored in un_value field.

Note
  It is possible to speed up parsing process by creating a parser which does understand only a minimum number of headers. If such a parser is used, some well-known headers are regarded as unknown and put into list of unknown headers.

The structure sip_unknown_t contains representation of unknown headers.

The sip_unknown_t is defined as follows:

typedef struct msg_unknown_s {
msg_common_t un_common[1]; // Common fragment info
msg_unknown_t *un_next; // Link to next unknown header
char const *un_name; // Header name
char const *un_value; // Header field value
} sip_unknown_t;
msg_unknown_t
struct msg_unknown_s msg_unknown_t
msg_common_t
struct msg_common_s msg_common_t
msg_unknown_s
msg_unknown_s::un_common
msg_common_t un_common[1]
msg_unknown_s::un_next
msg_unknown_t * un_next
msg_unknown_s::un_name
char const * un_name
msg_unknown_s::un_value
char const * un_value

## Function Documentation

## sip_is_unknown()

int sip_is_unknown | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_unknown_t.

Check if the header class is an instance of unknown headers object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header unknown
  0 | (false) otherwise

## sip_unknown_copy()

sip_unknown_t * sip_unknown_copy | ( | su_home_t * | home,
|  | sip_unknown_t const * | hdr )

inline

Copy a list of unknown headers header structures sip_unknown_t.

The function sip_unknown_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  unknown = sip_unknown_copy(home, sip->sip_unknown);
  sip_unknown_copy
  sip_unknown_t * sip_unknown_copy(su_home_t *home, sip_unknown_t const *hdr))
  Copy a list of unknown headers header structures sip_unknown_t.
  Definition sip_protos.h:16224

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_unknown_dup()

sip_unknown_t * sip_unknown_dup | ( | su_home_t * | home,
|  | sip_unknown_t const * | hdr )

inline

Duplicate a list of unknown headers header structures sip_unknown_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  unknown = sip_unknown_dup(home, sip->sip_unknown);
  sip_unknown_dup
  sip_unknown_t * sip_unknown_dup(su_home_t *home, sip_unknown_t const *hdr))
  Duplicate a list of unknown headers header structures sip_unknown_t.
  Definition sip_protos.h:16181

Returns
  A pointer to the newly duplicated sip_unknown_t header structure, or NULL upon an error.

## sip_unknown_format()

sip_unknown_t * sip_unknown_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a unknown headers from formatting result.

Make a new sip_unknown_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_unknown_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_unknown_init()

sip_unknown_t * sip_unknown_init | ( | sip_unknown_t | x[1] | ) |

inline

Initialize a structure sip_unknown_t.

An sip_unknown_t structure for unknown headers can be initialized with the sip_unknown_init() function/macro. For instance,

sip_unknown_t sip_unknown;
sip_unknown_init(&sip_unknown);
sip_unknown_init
sip_unknown_t * sip_unknown_init(sip_unknown_t x[1])
Initialize a structure sip_unknown_t.
Definition sip_protos.h:16112

## sip_unknown_make()

sip_unknown_t * sip_unknown_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a unknown headers structure sip_unknown_t.

The function sip_unknown_make() makes a new sip_unknown_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_unknown_t header structure, or NULL upon an error.

## Variable Documentation

## sip_unknown_class

msg_hclass_t sip_unknown_class[]

extern

Header class for unknown headers.

The header class sip_unknown_class defines how a SIP unknown headers is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_unknown_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.